/**
 * <p>Title: BlablaServeur</p>
 * <p>Company: Minosis.com</p>
 * <p>Date: 27/03/2005</p>
 * @author Minosis - Julien Defaut
 * @version 1.0
 */

import java.net.*;
import java.io.*;

//** Classe associe  chaque client **
//** Il y aura autant d'instance de cette classe que de client connects **
//implmentation de l'interface Runnable (une des 2 mthodes pour crer un thread)
class BlablaThread implements Runnable
{
  private Thread _t; // contiendra le thread du client
  private Socket _s; // recevra le socket liant au client
  private PrintWriter _out; // pour gestion du flux de sortie
  private BufferedReader _in; // pour gestion du flux d'entre
  private BlablaServ _blablaServ; // pour utilisation des mthodes de la classe principale
  private int _numClient=0; // contiendra le numro de client gr par ce thread

  //** Constructeur : cre les lments ncessaires au dialogue avec le client **
  BlablaThread(Socket s, BlablaServ blablaServ) // le param s est donne dans BlablaServ par ss.accept()
  {
    _blablaServ=blablaServ; // passage de local en global (pour gestion dans les autres mthodes)
    _s=s; // passage de local en global
    try
    {
      // fabrication d'une variable permettant l'utilisation du flux de sortie avec des string
      _out = new PrintWriter(_s.getOutputStream());
      // fabrication d'une variable permettant l'utilisation du flux d'entre avec des string
      _in = new BufferedReader(new InputStreamReader(_s.getInputStream()));
      // ajoute le flux de sortie dans la liste et rcupration de son numero
      _numClient = blablaServ.addClient(_out);
    }
    catch (IOException e){ }

    _t = new Thread(this); // instanciation du thread
    _t.start(); // demarrage du thread, la fonction run() est ici lance
  }

  //** Methode :  excute au lancement du thread par t.start() **
  //** Elle attend les messages en provenance du serveur et les redirige **
  // cette mthode doit obligatoirement tre implmente  cause de l'interface Runnable
  public void run()
  {
    String message = ""; // dclaration de la variable qui recevra les messages du client
    // on indique dans la console la connection d'un nouveau client
    System.out.println("Un nouveau client s'est connecte, no "+_numClient);
    try
    {
      // la lecture des donnes entrantes se fait caractre par caractre ...
      // ... jusqu' trouver un caractre de fin de chaine
      char charCur[] = new char[1]; // dclaration d'un tableau de char d'1 lement, _in.read() stockera y le char lu
      while(_in.read(charCur, 0, 1)!=-1) // attente en boucle des messages provenant du client (bloquant sur _in.read())
      {
      	// on regarde si on arrive  la fin d'une chaine ...
        if (charCur[0] != '\u0000' && charCur[0] != '\n' && charCur[0] != '\r')
                message += charCur[0]; // ... si non, on concatne le caractre dans le message
        else if(!message.equalsIgnoreCase("")) // juste une vrification de principe
        {
          if(charCur[0]=='\u0000') // le dernier caractre tait '\u0000' (char de terminaison nulle)
          	// on envoi le message en disant qu'il faudra concatner '\u0000' lors de l'envoi au client
            _blablaServ.sendAll(message,""+charCur[0]);
          else _blablaServ.sendAll(message,""); // sinon on envoi le message  tous
          message = ""; // on vide la chaine de message pour qu'elle soit rutilise
        }
      }
    }
    catch (Exception e){ }
    finally // finally se produira le plus souvent lors de la deconnexion du client
    {
      try
      {
      	// on indique  la console la deconnexion du client
        System.out.println("Le client no "+_numClient+" s'est deconnecte");
        _blablaServ.delClient(_numClient); // on supprime le client de la liste
        _s.close(); // fermeture du socket si il ne l'a pas dj t ( cause de l'exception leve plus haut)
      }
      catch (IOException e){ }
    }
  }
}
