/**
 * <p>Title: BlablaServeur</p>
 * <p>Company: Minosis.com</p>
 * <p>Date: 27/03/2005</p>
 * @author Minosis - Julien Defaut
 * @version 1.0
 */

import java.io.*;

//** Classe qui gre les commandes tappes dans la console **
// implmentation de l'interface Runnable (une des 2 mthodes pour crer un thread)
class Commandes implements Runnable
{
  BlablaServ _blablaServ; // pour utilisation des mthodes de la classe principale
  BufferedReader _in; // pour gestion du flux d'entre (celui de la console)
  String _strCommande=""; // contiendra la commande tape
  Thread _t; // contiendra le thread

  //** Constructeur : initialise les variables ncessaires **
  Commandes(BlablaServ blablaServ)
  {
    _blablaServ=blablaServ; // passage de local en global
    // le flux d'entre de la console sera gr plus pratiquement dans un BufferedReader
    _in = new BufferedReader(new InputStreamReader(System.in));
    _t = new Thread(this); // instanciation du thread
    _t.start(); // demarrage du thread, la fonction run() est ici lance
  }

  //** Methode : attend les commandes dans la console et excute l'action demande **
  public void run() // cette mthode doit obligatoirement tre implmente  cause de l'interface Runnable
  {
    try
    {
      // si aucune commande n'est tappe, on ne fait rien (bloquant sur _in.readLine())
      while ((_strCommande=_in.readLine())!=null)
      {
        if (_strCommande.equalsIgnoreCase("quit")) // commande "quit" detecte ...
          System.exit(0); // ... on ferme alors le serveur
        else if(_strCommande.equalsIgnoreCase("total")) // commande "total" detecte ...
        {
          // ... on affiche le nombre de clients actuellement connects
          System.out.println("Nombre de connectes : "+_blablaServ.getNbClients());
          System.out.println("--------");
        }
        else
        {
          // si la commande n'est ni "total", ni "quit", on informe l'utilisateur et on lui donne une aide
          System.out.println("Cette commande n'est pas supportee");
          System.out.println("Quitter : \"quit\"");
          System.out.println("Nombre de connectes : \"total\"");
          System.out.println("--------");
        }
        System.out.flush(); // on affiche tout ce qui est en attente dans le flux
      }
    }
    catch (IOException e) {}
  }
}
